/*----------------------------------------------------------*
   STM32F373p ȈՃu[g[_ Ver 1.0
                                       Last Edit '14 02/17
   Copyright (c) BestTechnology CO.,LTD. 2013-2014
 *----------------------------------------------------------*/

/*---------------------------------------------------------------------*
 Tv

  ST STM32F373̓tbVAvP[VB
  [U[vO͎኱̃gbNKvȂ̂ŁAGCC Developer Lite 
  K؂ɑIIvVŃRpCoCigp̎B

 RpC̒ӎ

  1.RpC\Ȋ
   ŐV GCC Developer Lite  STM32F373 ^[Qbgt@C܂ތ`ŃC
   Xg[Ă邱ƁB

  2.RpCyяݕ@
   -Os̍œKw肵ăRpCB
   RpC JTAG  DFU ɂď݂sB

 [UvOɊւ

  1.u[gAhX
   0x08004000

 XV

  Ver.0.1 2013/06/10
     SAM3SySTM32F2xxقڂ̂܂܈ڍsB
     USB(cdcG~[V)݂̂ƂB
     ɑ傫Ȗ͔B

  Ver.0.2 2013/08/04
     u[g[_ŎgpĂytF̍ďʓ|Ȃ̂ŁA蓮
     Wv̓\tgZbgɂċN𑣂ƂB
     ɏ]̃~XCB
     USB̃vAbvZbg[qɘAĂ鎖ǂ邩->
       OtUSBnu𒆌p邱ƂŃguyƂ

  Ver.0.3 2013/08/11
     zXgɂ|[g̃I[vfoCXDTRɂĔ肷lɃCu
     CƂɔC

  Ver.0.4 2013/08/14
     ͈͊Ö̗DUMPHARD FAULT𖾎Iɕ\

  Ver.0.5 2014/02/01
     USB̉HύXɔUSB CDC EMU̕ύX̓Kp

  Ver.1.0 2014/02/14
     [X

 *---------------------------------------------------------------------*/

#include  <stdarg.h>
#include  <stdint.h>
#include  <string.h>
#include  <ctype.h>

#include  <stm32f37x.h>
#include  <stm32f37x_conf.h>
#include  <lowlevel.h>
#include  <us.h>
#include  <piocfg.h>


/* {[[g(x̓|[gɈˑ̂Œ) */
#define _BAUDRATE                 (1000000)

#define _USE_DOWNLOAD

/* pPbgTCY͈ȉ128/1024̂ꂩ */
#if 1
#define _XMODEM_PACKET_SIZE       (128)
#else
#define _XMODEM_PACKET_SIZE       (1024)
#endif

#define us_init                   usb_init
#define us_rx_buff                usb_rx_buff
#define us_rx_purge               usb_rx_purge
#define us_putc                   usb_putc
#define us_getc                   usb_getc
#define us_puts                   usb_puts
#define us_putsb                  usb_putsb
#define PORTNAME                  "USB"

#define FLASH_PAGE_SIZE           (0x00000400)
#define USER_FLASH_START_ADDRESS  (0x08004000)
#define USER_FLASH_END_ADDRESS    (0x0803FFFF)
#define USER_FLASH_SIZE           (USER_FLASH_END_ADDRESS - USER_FLASH_END_ADDRESS + 1)

#define _SOH                      (0x01)
#define _STX                      (0x02)
#define _EOT                      (0x04)
#define _ACK                      (0x06)
#define _NAK                      (0x15)
#define _CAN                      (0x18)
#define _XYN                      (_NAK)
#define _XYC                      ('C')
#define _XYG                      ('G')

char txb[_XMODEM_PACKET_SIZE + 20], rxb[_XMODEM_PACKET_SIZE + 20];
#ifdef LED
int duty = 100;
#endif

const char *mess[2] = {
  // 0
//  "\n--< TIMSTM32F3 "PORTNAME" Ver.0.4 by BestTechnology >-- "__TIME__" "__DATE__,
  "\n--< TIMSTM32F3 "PORTNAME" Ver.1.0 by BestTechnology >-- "
  // 1
#ifdef _USE_DOWNLOAD
  "\n [w]UPLOAD [r]DOWNLOAD [g]BOOT [d]DUMP"
  " [i]FLASH INFO [e]ERASE"// [l]SET LOCK BIT [u]CLEAR LOCK BIT"
#else
  "\n [w]UPLOAD [g]BOOT [d]DUMP"
  " [i]FLASH INFO [e]ERASE"// [l]SET LOCK BIT v[u]CLEAR LOCK BIT"
#endif
};

typedef void (*fp)(void);

/*======================================================================*/
/* WAIT                                                                 */
/*======================================================================*/
volatile uint32_t msTicks = 0;

bool wait (uint32_t delay, bool rx) {
  volatile uint32_t cur;
  cur = msTicks;
  while ((msTicks - cur) < delay) {
    if (rx) if (us_rx_buff ()) return true;
  }
  return false;
}

#define STM32_CLOCK_HZ 72000000UL
#define STM32_CYCLES_PER_LOOP 6 // This will need tweaking or calculating

void delay_ms (uint32_t ms) {
    ms *= STM32_CLOCK_HZ / 1000 / STM32_CYCLES_PER_LOOP;

    asm volatile(" mov r0, %[ms] \n\t"
             "1: subs r0, #1 \n\t"
             " bhi 1b \n\t"
             :
             : [ms] "r" (ms)
             : "r0");
}

/*======================================================================*/
/* INIT                                                                 */
/*======================================================================*/
extern void FLASH_If_Init (void);

void Init (void) {
  SysTick->CTRL = 0;
  SysTick_Config (72000000 / 7200);

#ifdef LED
  PIO_Configure (pins, PIO_LISTSIZE (pins));
#endif
  us_init (0, 0, txb, sizeof(txb), rxb, sizeof(rxb));
}

void Deinit (void) {
  usb_deinit ();

  SysTick->CTRL = 0;
  SysTick->LOAD = 0;
  SysTick->VAL = 0;
}

/*======================================================================*/
/* FLASH CONTROL                                                        */
/*======================================================================*/
void FLASH_If_Init (void) { 
  FLASH_ClearFlag (FLASH_FLAG_EOP | FLASH_FLAG_PGERR | FLASH_FLAG_WRPERR); 
  FLASH_Unlock();
}

uint32_t FLASH_If_Write (uint32_t destaddr, uint32_t* Data ,uint16_t DataLength) {
  uint32_t i = 0;

  if (destaddr > (USER_FLASH_END_ADDRESS - 4)) return 2;
  for (i = 0; (i < DataLength) && (destaddr <= (USER_FLASH_END_ADDRESS - 4)); i++) {
    if (FLASH_ProgramWord (destaddr, *(uint32_t*)(Data + i)) == FLASH_COMPLETE) {
      if (*(uint32_t*)destaddr != *(uint32_t*)(Data+i)) return 2;
      destaddr += 4;
    } else return 1;
  }
  return 0;
}

bool EraseFlashAll (void) {
  bool      noterased;
  int       i, j;
  uint32_t  npage = (USER_FLASH_END_ADDRESS - USER_FLASH_START_ADDRESS) / FLASH_PAGE_SIZE;

  FLASH_If_Init ();
  for (i = 0; i < npage; i++) {
    for (j = 0; j < FLASH_PAGE_SIZE >> 2; j += 4) {
      if ((noterased = (*(uint32_t *)(USER_FLASH_START_ADDRESS + (FLASH_PAGE_SIZE * i) + j)) != 0xffffffff)) break;
    }
    if (i % 15 == 0) us_putc ('.');
    if (noterased) {
      if (FLASH_ErasePage (USER_FLASH_START_ADDRESS + (FLASH_PAGE_SIZE * i)) != FLASH_COMPLETE) return false;
    }
  }
  return true;
}

/*======================================================================*/
/* ETC                                                                  */
/*======================================================================*/
extern bool USB_PortOpened (void);

bool port_opened (void) {
  return true;
}

int ResetType (void) {
  static bool first = true;
  static uint8_t r = 0;

  if (first) {
    r = RCC->CSR >> 25;
    RCC->CSR |= RCC_CSR_RMVF;
    first = false;
  }
  if (r == 0x2) return 6;       // pin
  else if ((r & 0x1) != 0) return 1;   // obl
  else if ((r & 0x4) != 0) return 0;   // por
  else if ((r & 0x8) != 0) return 2;   // sft
  else if ((r & 0x10) != 0) return 3;  // iwdg
  else if ((r & 0x20) != 0) return 4;  // wwdg
  else if ((r & 0x40) != 0) return 5;  // lpwr
  else return -1;
}

char *I2H (int64_t v, int len, char *s) {
  const char hex_code[] = "0123456789ABCDEF";
  memset (s, '0', len);
  s[len] = 0;
  do {
    s[--len] = hex_code[v & 0xf];
    v >>= 4;
  } while (len && v);
  return s;
}

int64_t H2I (char *s) {
  int64_t i, n = 0;

  if (!*s) return -1;
  for (i = 0; *s; i++, s++) {
    if ('0' <= *s && *s <= '9') {
      n <<= 4;
      n |= *s - '0';
    } else if ('a' <= *s && *s <= 'f') {
      n <<= 4;
      n |= *s - ('a' - 10);
    } else if ('A' <= *s && *s <= 'F') {
      n <<= 4;
      n |= *s - ('A' - 10);
    }
  }
  return n;
}

int D2I (char *buf, int len) {
  int i = 0, ret = 0;

  for (i = 0; i < len; i++) {
    if (('0' <= buf[i]) && (buf[i] <= '9')) {
      ret *= 10;
      ret += (buf[i] - 48);
    } else if (buf[i] == '\0') break;
  }
  return ret;
}

void H2B (char *h, int len, uint8_t *b) {
  int i = 0;

  b--;
  do {
    if ((i++ % 2) == 0) b++;
    if (*h >= 'A' && *h <= 'F') *b = (*b & 0xf0) | ((*h - 'A' + 10) & 0xf);
    else                        *b = (*b & 0xf0) | ((*h - '0') & 0xf);
    if ((i % 2) == 1) *b <<= 4;
    h++;
  } while (i < len);
}

void JumpToUserProgram (void) {
  void (*UserProgram)(void) = (fp)*(uint32_t*)(USER_FLASH_START_ADDRESS + 4);
  __set_MSP (*(uint32_t*)USER_FLASH_START_ADDRESS);
  UserProgram ();
}

bool AreYouSure (const char *s) {
  char c;
  us_puts (s);
  us_puts ("\n ARE YOU SURE? (Y/N) ");
  us_putc ((c = us_getc ()));
  return (c == 'y' || c == 'Y');
}

bool FlashIsNotEmpty (void) {
  uint32_t *FWBOOT = (uint32_t *)USER_FLASH_START_ADDRESS;
  return (((*FWBOOT & 0x2FFE0000) == 0x20000000) || ((*FWBOOT & 0x2FFE0000) == 0x20020000)) && (*FWBOOT != 0xffffffff);
}

void us_hex_puts (char *s1, char *s2, long num, int d) {
  char s[20];
  us_puts (s1);
  us_puts (I2H (num, d, s));
  us_puts (s2);
}

/*======================================================================*/
/* OTHER TX/RX ROUTINES                                                 */
/*======================================================================*/
typedef enum {
  mode_str,
  mode_hex,
  mode_dec,
} TCharMode;

char *getstr (char *s, int len, TCharMode m) {
  int i = 0;
  char c;

  while (1) {
    c = us_getc ();
    if (c == '\n' || c == '\r') {
      s[i++] = '\0';
      break;
    } else if ((i > 0) && (c == '\b')) {
      us_puts ("\b \b");
      i--;
    } else if ((i < len) && (i >= 0) && (c >= ' ') && (c <= '~')) {
      switch (m) {
        case mode_dec:
          if ((c >= '0') && (c <= '9')) {
            s[i++] = (char)c;
            us_putc (c);
          }
          break;
        case mode_hex:
          if (((c >= '0') && (c <= '9')) || ((c >= 'a') && (c <= 'f')) || ((c >= 'A') && (c <= 'F'))) {
            s[i++] = c;
            us_putc (c);
          }
          break;
        default:
         s[i++] = (char)c;
         us_putc (c);
         break;
      }
    } else us_putc ('\a');
  }
  return s;
}

/*======================================================================*/
/* XMODEM                                                               */
/*======================================================================*/
#define _SOH                (0x01)
#define _STX                (0x02)
#define _EOT                (0x04)
#define _ACK                (0x06)
#define _NAK                (0x15)
#define _CAN                (0x18)
#define _XYN                (_NAK)
#define _XYC                ('C')
#define _XYG                ('G')

#if 1
#define _XMODEM_PACKET_SIZE (128)
#else
#define _XMODEM_PACKET_SIZE (1024)
#endif
/*-----XMODEM̃pPbg-------*
  M              M
         --- NAK -->
         <-- SOH --- (128bytẽubNJn)
         <--  01 --- (ubNԍ)
         <--  FE --- (ubNԍ𔽓])
         <--  .. --- (ۂ̃f[^ 128 bytes)
              ..
         <-- sum --- (checksum)

         --- ACK -->
 *--------------------------------*/
/*-----XMODEM1k̃pPbg-------*
  M              M
         --- 'C' -->
         <-- STX --- (1024bytẽubNJn)
         <--  01 --- (ubNԍ)
         <--  FE --- (ubNԍ𔽓])
         <--  .. --- (ۂ̃f[^ 1024 bytes)
              ..
         <-- sumH --- (CRC)
         <-- sumL --- (CRC)

         --- ACK -->
 *--------------------------------*/
#define _CNTOVER  (5)

#define FLASH_ADDRESS                 0x08008000
#if 1
#define _XMODEM_PACKET_SIZE (128)
#else
#define _XMODEM_PACKET_SIZE (1024)
#endif

uint32_t XmodemRX (void) {

  bool my_put_ack (void) {
    char i = 0;
    for (i = 0; i < _CNTOVER; i++) {
      us_putc (_ACK);  // OK
      if (wait (100, true)) return true;
    }
    return false;
  }

  bool my_get_char (uint8_t *ch, bool f) {
    int cntover = 0;

    if (wait (50, true)) {
      *ch = (uint8_t)us_getc ();
      return true;
    } else {
      if (f) {
        wait (100, false);
        us_rx_purge ();
        do {
          us_putc (_NAK);
          wait (100, true);
          if (cntover++ > _CNTOVER) break;
        } while (!us_rx_buff ());
      }
      return false;
    }
  }

  uint8_t xbuff[2048], head, sum0 = 0, sum1, h0 = 1, h1, h2;
  uint16_t sum2;
  int  i = 0;
  uint32_t  size = 0, adr = 0, fladdr = USER_FLASH_START_ADDRESS;
  bool f;

  while (!us_rx_buff ()) {
#if _XMODEM_PACKET_SIZE == 128
    us_putc (_NAK);
#else
    us_putc (_XYC);
#endif
    if (wait (100, true)) break;
    if (i++ > 240) return 0;
  }
  for (;;) {
    if (my_get_char (&head, true)) {
      switch (head) {
#if _XMODEM_PACKET_SIZE == 128
        case _SOH:
#else
        case _STX:
#endif
          if (my_get_char (&h1, false)) {
            if (my_get_char (&h2, false)) {
              if (h1 != ((~h2) & 0xff)) {
                wait (50, false);
                us_rx_purge ();
                us_putc (_NAK);
              } else {
                if (h1 == h0) {
                  sum2 = 0;
                  f = false;
                  for (i = 0; i < _XMODEM_PACKET_SIZE; i++) {
                    if ((f = my_get_char (&xbuff[adr + i], false))) {
#if _XMODEM_PACKET_SIZE == 128
                      sum2 = (sum2 + xbuff[adr + i]) & 0xff;
#else
                      sum2 = sum2 ^ xbuff[adr + i] << 8;
                      int  j;
                      for (j = 0; j < 8; ++j) {
                        if (sum2 & 0x8000) sum2 = sum2 << 1 ^ 0x1021;
                        else               sum2 = sum2 << 1;
                      }
#endif
                    } else break;
                  }
                  if (f) {
#if _XMODEM_PACKET_SIZE == 128
                    if (my_get_char (&sum1, false))
#else
                    if (my_get_char (&sum0, false) && my_get_char (&sum1, false))
#endif
                    {
                      if (((sum0 << 8) | sum1) == sum2) {
                        adr += _XMODEM_PACKET_SIZE;
                        h0++;
                        if ((adr % sizeof (xbuff)) == 0) {
                          if (FLASH_If_Write (fladdr, (void *)xbuff, sizeof(xbuff) / 4) == 0) {
                            fladdr += sizeof (xbuff);
                            adr = 0;
                          } else {
                            us_putc (_CAN);
                            wait (50, false);
                            us_rx_purge ();
                            return 0;
                          }
                        }
                        size += _XMODEM_PACKET_SIZE;
                        if (!my_put_ack ()) { // OK
                          us_putc (_CAN);
                          wait (50, false);
                          us_rx_purge ();
                          return 0;
                          break;
                        }
                      } else {
                        wait (50, false);
                        us_rx_purge ();
                        us_putc (_NAK);
                      }
                    }
                  } else {
                    wait (50, false);
                    us_rx_purge ();
                    us_putc (_NAK);
                  }
                }
              }
            }
          }
          break;
        case _EOT:
          if (adr) {
//            if (!FL_WriteFlash (fladdr, adr, (void *)xbuff)) {
            if (!(FLASH_If_Write (fladdr, (void *)xbuff, adr / 4) == 0)) {
              us_putc (_CAN);
              wait (50, false);
              us_rx_purge ();
              return 0;
            }
          }
          us_rx_purge ();
          us_putc (_ACK);
          wait (10, false);
          return size + adr;
          break;
        case _CAN:
          wait (50, false);
          us_rx_purge ();
          return 0;
          break;
        default:
          wait (50, false);
          us_rx_purge ();
          us_putc (_NAK);
          break;
      }
    }
  }
}

int getc2 (int w) {
  wait (w, true);
  if (us_rx_buff ()) return us_getc ();
  return -1;
}

#ifdef _USE_DOWNLOAD
int XmodemTX (uint8_t *src, int srcsz) {
  uint16_t sum2;
  uint8_t  xbuff[_XMODEM_PACKET_SIZE + 30], packetno = 1;
  int packetsize = 0, i, j, c, len = 0, retry = 0;
  bool crc = false;

  while (!us_rx_buff ()) {
    if (wait (100, true)) {
      switch (c = us_getc ()) {
        case _XYC:  // 1kbyte
          crc = true;
          packetsize = 1024;
          break;
        case _NAK:  // 128byte
          crc = false;
          packetsize = 128;
          break;
        case _CAN:  // canceled by remote
          wait (50, false);
          us_rx_purge ();
          us_putc (_ACK);
          return -1;
          break;
        default:    // cancel
          wait (50, false);
          us_rx_purge ();
          us_putc (_CAN);
          return -1;
          break;
      }
      break;
    }
    if (retry++ > _CNTOVER * 10) return -1;
  }

  for (;;) {
    xbuff[0] = crc ? _STX : _SOH;
    xbuff[1] = packetno;
    xbuff[2] = ~packetno;
    if ((c = srcsz - len) > packetsize) c = packetsize;
    if (c >= 0) {
      memset (&xbuff[3], 0xff, packetsize);
      sum2 = 0;
      for (i = 0; i < packetsize; i++) {
        xbuff[3 + i] = src[len + i];
        if (crc) {
          sum2 = sum2 ^ xbuff[3 + i] << 8;
          for (j = 0; j < 8; ++j) {
            if (sum2 & 0x8000) sum2 = sum2 << 1 ^ 0x1021;
            else               sum2 = sum2 << 1;
          }
        } else sum2 = (sum2 + xbuff[3 + i]) & 0xff;
      }
      if (crc) {
        xbuff[packetsize + 3] = (sum2 >> 8) & 0xFF;
        xbuff[packetsize + 4] = sum2 & 0xFF;
      } else xbuff[packetsize + 3] = sum2;
      for (retry = 0; retry < _CNTOVER; ++retry) {
        us_putsb ((char *)xbuff, packetsize + 4 + (crc ? 1 : 0));
        if ((c = getc2 (200)) >= 0) {
          switch (c) {
            case _ACK:  // ok
              packetno++;
              len += packetsize;
              retry = _CNTOVER;
              break;
            case _CAN:  // canceled by remote
              wait (50, false);
              us_rx_purge ();
              us_putc (_ACK);
              return -1;
              break;
            case _NAK:  // retry
            default:
              wait (50, false);
              us_rx_purge ();
              break;
          }
        }
      }
      if (c != _ACK) {
        wait (50, false);
        us_rx_purge ();
        us_putc (_CAN);
        return -1;
      }
    } else {
      for (retry = 0; retry < _CNTOVER; retry++) {
        us_putc (_EOT);
        if ((c = getc2 (500)) == _ACK) break;
      }
      us_rx_purge ();
      return (c == _ACK) ? len : -5;
    }
  }
}
#endif

/*======================================================================*/
/* DUMP                                                                 */
/*======================================================================*/
void dump (uint32_t addr) {
  uint32_t i, j;
  uint8_t *dat = (uint8_t *)addr;
  char s[80], c;
  while (1) {
    s[0] = ' ';
    for (i = 0; i < 16; i++) {
      I2H ((uint32_t)(dat + (i << 4)), 8, &s[1]);
      s[9] = ':';
      for (j = 0; j < 16; j++) {
        I2H (dat[(i << 4) + j], 2, &s[10 + j * 3]);
        s[12 + j * 3] = ' ';
      }
      s[57] = ' ';
      for (j = 0; j < 16; j++) {
        c = dat[(i << 4) + j];
        s[58 + j] = ((0x20 <= c) && (c < 0x7f)) ? c : '.';
      }
      s[74] = '\n';
      s[75] = '\0';
      us_puts(s);
    }
    us_puts ("---([u]up [d]down [ESC]exit)---\n");
    switch (us_getc ()) {
      case 0x1b:
      case 'q':
      case 'Q':
        return;
        break;
      case ' ':
      case 'u':
      case 'U':
      case '\r':
        dat += 256;
        break;
      case 'd':
      case 'D':
        dat -= 256;
        break;
    }
#ifdef LED
    duty = 100;
#endif
  }
}

/*======================================================================*/
/* INTERVAL TIMER  (1ms)                                                */
/*======================================================================*/
void SysTick_Handler (void) {
  volatile static int divq = 0;

  WWDG_ClearFlag ();

  if (divq++ > 10) {
    msTicks++;
    divq = 0;
  }

#ifdef LED
  static int freq = 0;

  if (duty > 0) {
    if (++freq > 100) {
      freq = 0;
      duty -= 3;
    }
    if (duty > 0) {
      if (duty <= freq) PIOA->PIO_SODR = _LED;
      else              PIOA->PIO_CODR = _LED;
    } else {
      PIOA->PIO_SODR = _LED;
      freq = 0;
    }
  }
#endif
}

/*======================================================================*/
/* REPLACE RESETEXCEPTION HANDLER                                       */
/*======================================================================*/
extern uint32_t _estack;
extern uint32_t _sfixed;
extern uint32_t _etext;
extern uint32_t _data;
extern uint32_t _edata;
extern uint32_t __bss_start__;
extern uint32_t __bss_end__;

#define SCB_VTOR_MASK         (0xFFFFFF80)
#define SCB_VTOR_TBLBASE_Pos  29                                             /*!< SCB VTOR: TBLBASE Position */
#define SCB_VTOR_TBLBASE_Msk  (1UL << SCB_VTOR_TBLBASE_Pos)                  /*!< SCB VTOR: TBLBASE Mask */

extern void main (void);
extern void __libc_init_array (void) __attribute__ ((weak));

extern void USB_Cable_Config (FunctionalState NewState);

void ResetException (void) {
  uint32_t *s, *d;

  // Initialize the relocate segment
  s = &_etext;
  d = &_data;
  if (s != d) for (; d < &_edata;) *d++ = *s++;
  // Clear the zero segment
  for (d = &__bss_start__; d < &__bss_end__;) *d++ = 0;

  // Branch to user program
  if (ResetType () != 6 && FlashIsNotEmpty ()) {
    JumpToUserProgram ();
  // Branch to main function of bootloader
  } else {
    LowLevelInit ();
    // Set the vector table base address
    s = (uint32_t *)&_sfixed;
    SCB->VTOR = ((uint32_t)(s)) & SCB_VTOR_MASK;
    if (((uint32_t)s >= SRAM_BB_BASE) && ((uint32_t)s < SRAM_BB_BASE+0x8000)) SCB->VTOR |= 1 << SCB_VTOR_TBLBASE_Pos;
    __libc_init_array ();
    main ();
  }
}

void main (void) {
  int64_t i, j;
  char ch = '\0', s[20];

  const char *resetmess[7] ={
    "\n POR/PDR Reset",
    "\n OBL reset",
    "\n Software Reset",
    "\n IW-Watchdog Reset",
    "\n Watchdog Reset",
    "\n Low-power Reset",
    "\n User Reset"
  };
  char bs[] ="\33[0D";

  Init ();

  wait (300,false);
  // Send boot messages
  us_puts ((char *)resetmess[ResetType ()]);
  us_puts ((char *)mess[0]);

  for (;;) {
    us_rx_purge ();
    us_puts ("\n>");
    us_putc (ch = us_getc ());

#ifdef LED
    duty = 100;
#endif
    switch (tolower ((int)ch)) {
      case 'w':
        FLASH_If_Init ();
        if (AreYouSure ("\n START UPLOAD...")) us_puts (XmodemRX () ? "\n <SUCCESS>" : "\n <ERROR>");
        break;
#ifdef _USE_DOWNLOAD
      case 'r':
        us_puts ("\n START ADDRESS:$");
        if ((i = H2I (getstr (s, 8, mode_hex))) < 0) i = USER_FLASH_START_ADDRESS;
        bs[2] = strlen(s) + 0x30;
        us_hex_puts (bs, "\n SiZE:$", i, 8);
        if ((j = H2I (getstr (s, 8, mode_hex))) < 0) j = USER_FLASH_SIZE;
        bs[2] = strlen(s) + 0x30;
        us_hex_puts (bs, "\n START DOWNLOAD...", j, 8);
        if (AreYouSure ("")) us_puts (XmodemTX ((uint8_t *)(uint32_t)i, j) ? "\n <SUCCESS>" : "\n <ERROR>");
        break;
#endif
      case 'g':
        if (FlashIsNotEmpty ()) {
          us_puts ("\n GO !!\n");
          wait (20, true);
          Deinit ();
          NVIC_SystemReset ();
        } else us_puts ("\n FLASH IS EMPTY");
        break;
      case 'e':
        if (AreYouSure ("\n ERASE ALL FLASH")) {
          us_puts (EraseFlashAll () ? "\n <SUCCESS>" : "\n <ERROR>");
        }
        break;
      case 'i':
        us_puts (FlashIsNotEmpty () ? "\n FLASH: Not Empty": "\n FLASH: Empty or Not Executable");
        us_puts ("\n OPTION BYTE:");
        for (i = 0; i < 4; i++) {
          us_puts(" $");
          us_puts(I2H (*(uint32_t *)(0x1ffff800U + (i << 2)), 8, s));
        }
        break;
      case 'd':
        us_puts ("\n START ADDRESS:$");
        if ((i = H2I (getstr (s, 8, mode_hex))) < 0) i = USER_FLASH_START_ADDRESS;
        bs[2] = strlen(s) + 0x30;
        us_hex_puts (bs, "\n", i, 8);
        dump (i);
        break;
      case 'x':
        wait (20, true);
        usb_deinit ();
        NVIC_SystemReset ();
        break;
      case '?':
        us_puts ((char *)mess[0]);
        us_puts ((char *)mess[1]);
        break;
    }
  }
}

void HardFault_Handler (void) { us_puts ("\nHardFault!!\n"); }
void MemManage_Handler(void) { us_puts ("\nMemManage!!\n"); }
void BusFault_Handler(void) { us_puts ("\nnBusFault!!\n"); }
